# Contributing to 1984
Contributions are loved here. I try to make it as simple and straightforward as possible. Welcome contributions are:

- Reporting a bug
- Reporting clean code issues
- Submitting a fix
- Proposing new features

## We Develop with Github
I use github to host code, to track issues and feature requests, as well as accept pull requests.

## We Use [Github Flow](https://guides.github.com/introduction/flow/index.html), So All Code Changes Happen Through Pull Requests
Pull requests are the best way to propose changes to the codebase. To make it easier follow these steps:

1. Fork the repo and create your branch from `master`.
2. Add sufficient tests.
4. Ensure the test suite passes.
5. Make sure your code lints.
6. Issue that pull request!

## Any contributions you make will be under the MIT Software License
In short, when you submit code changes, your submissions are understood to be under the same [MIT License](http://choosealicense.com/licenses/mit/) that covers the project. There are no exceptions to this.

## Report bugs using Github's [issues](https://github.com/idrinth/1984/issues)
We use GitHub issues to track public bugs. Report a bug by [opening a new issue](); it's that easy!

## Use a Consistent Coding Style
I am using [PSR-12](https://www.php-fig.org/psr/psr-12/) as coding style for php. Please follow it everywhere - it is automatically checked in pull requests.

## License
By contributing, you agree that your contributions will be licensed under its [MIT License](http://choosealicense.com/licenses/mit/).
